searchNodes=[{"ref":"Chunky.html","title":"Chunky","type":"module","doc":"Extended chunking and enumeration manipulations. Functions Chunky.permutations/1 - Generate all permutations of a set of values, with no duplication Chunky.combinations/2 - Generate combinations of a set of values, with no duplication Chunky.chunk_length/2 - Chunk an enumerable into specific length chunks For combinations and permutations, it can be helpful compare the differences: UnorderedOrdered No ReplacementChunky.combination/2`Chunky.permutation/1 Replacementunsupportedunsupported And expected outputs from simple string parameters: UnorderedOrdered No Replacement[ &quot;abc&quot;, &quot;abd&quot;, &quot;acd&quot;, &quot;bcd&quot;][&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] Replacement"},{"ref":"Chunky.html#chunk_length/2","title":"Chunky.chunk_length/2","type":"function","doc":"Break a set of values into smaller chunks of a specific length. iex&gt; Chunky.chunk_length([1, 2, 3, 4, 5, 6], 3) [ [1, 2, 3], [4, 5, 6]] iex&gt; Chunky.chunk_length(&quot;Sphinx of black quartz, judge my vow&quot;, 5) [&quot;Sphin&quot;, &quot;x of &quot;, &quot;black&quot;, &quot; quar&quot;, &quot;tz, j&quot;, &quot;udge &quot;, &quot;my vo&quot;, &quot;w&quot;] The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 When a set is chunked, the resulting list will contain values in the shape of the original; a chunked list will contains lists, chunked tuples will contain tuples, chunked strings will contain strings. The only exception is ranges, which will result in lists. Supported Chunking Types The following types of sets are supported for chunking: List A list with just about any kind of value can be chunked, and the result will be a list of lists: iex&gt; Chunky.chunk_length([1, 2, 3, 4, 5, 6, 7, 8], 3) [ [1, 2, 3], [4, 5, 6], [7, 8]] iex&gt; Chunky.chunk_length([:a, 1, :b, 2, :c, 3, :d, 4, :e, 5, :f, 6], 4) [ [:a, 1, :b, 2], [:c, 3, :d, 4], [:e, 5, :f, 6]] Collections, types, and other values can be in the chunked set: iex&gt; Chunky.chunk_length([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}, true], 2) [ [~D(2019-12-05), %{a: &quot;foo&quot;}], [{:tup, :le}, true]] String/Binary Chunked strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.chunk_length(&quot;abcdefghijklmnop&quot;, 7) [ &quot;abcdefg&quot;, &quot;hijklmn&quot;, &quot;op&quot;] iex&gt; Chunky.chunk_length(&quot;😀🤷🏽‍♀️⭐️℉😐&quot;, 3) [&quot;😀🤷🏽‍♀️⭐️&quot;, &quot;℉😐&quot;] Tuple When tuples are chunked, the resulting list will also contain tuples. As part of the chunking process the original tuple is converted to a list, before the final values are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.chunk_length({:a, :b, :c, :d, :e, :f, :g, :h, :i, :j}, 4) [ {:a, :b, :c, :d}, {:e, :f, :g, :h}, {:i, :j}] iex&gt; Chunky.chunk_length({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}, true, 123, &quot;foo&quot;}, 2) [ {:task, ~D(2019-12-09)}, {%{value: &quot;timer&quot;}, true}, {123, &quot;foo&quot;}] Ranges Ranges can be used to create chunks over ordered lists of numbers. Before chunking the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.chunk_length(1..20, 5) [ [1, 2, 3, 4, 5], [6, 7, 8, 9, 10], [11, 12, 13, 14, 15], [16, 17, 18, 19, 20]] iex&gt; Chunky.chunk_length(10..-10, 3) [ [10, 9, 8], [7, 6, 5], [4, 3, 2], [1, 0, -1], [-2, -3, -4], [-5, -6, -7], [-8, -9, -10] ]"},{"ref":"Chunky.html#combinations/2","title":"Chunky.combinations/2","type":"function","doc":"Generate the set of combinations from a set of values. The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 This is not lazy generated, so a combination of a large set may take awhile. Keep in mind that the total number of combinations of k length for a set of n values is: n! ---------- k!(n - k)! When a set is generated, the resulting list will contain values in the shape of the original; a combination from a list will contains lists, combination from tuples will contain tuples, combination from strings will contain strings. The only exception is ranges, which will result in lists. So, for instance, a combination from a string will result in a list of strings. Chunky should handle Unicode just fine: iex&gt; Chunky.combinations(&quot;😀★⍵😀🤷🏽‍♀️&quot;, 3) [&quot;😀★⍵&quot;, &quot;😀★😀&quot;, &quot;😀★🤷🏽‍♀️&quot;, &quot;😀⍵😀&quot;, &quot;😀⍵🤷🏽‍♀️&quot;, &quot;😀😀🤷🏽‍♀️&quot;, &quot;★⍵😀&quot;, &quot;★⍵🤷🏽‍♀️&quot;, &quot;★😀🤷🏽‍♀️&quot;, &quot;⍵😀🤷🏽‍♀️&quot;] Supported Combinations The Chunky.combinations/2 function can work with sets of any size (memory and time permitting). Examples that follow usually use sets with a length of 2 or 3 for ease of documentation. The following types of sets are supported as combinations: List A list with just about any kind of value can be permuted, and the result will be a list of lists: iex&gt; Chunky.combinations([1, 5, 7, 11, 27], 3) [[1, 5, 7], [1, 5, 11], [1, 5, 27], [1, 7, 11], [1, 7, 27], [1, 11, 27], [5, 7, 11], [5, 7, 27], [5, 11, 27], [7, 11, 27]] iex&gt; Chunky.combinations([:a, &quot;b&quot;, 3, 26.2], 2) [ [:a, &quot;b&quot;], [:a, 3], [:a, 26.2], [&quot;b&quot;, 3], [&quot;b&quot;, 26.2], [3, 26.2] ] Collections, types, and other values can be combined as well: iex&gt; Chunky.combinations([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}, [1, 2, 3]], 3) [ [~D[2019-12-05], %{a: &quot;foo&quot;}, {:tup, :le}], [~D[2019-12-05], %{a: &quot;foo&quot;}, [1, 2, 3]], [~D[2019-12-05], {:tup, :le}, [1, 2, 3]], [%{a: &quot;foo&quot;}, {:tup, :le}, [1, 2, 3]] ] String/Binary Combined strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.combinations(&quot;abcd&quot;, 2) [&quot;ab&quot;, &quot;ac&quot;, &quot;ad&quot;, &quot;bc&quot;, &quot;bd&quot;, &quot;cd&quot;] iex&gt; Chunky.combinations(&quot;😀🤷🏽‍♀️⭐️🧁🦴&quot;, 3) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀🤷🏽‍♀️🧁&quot;, &quot;😀🤷🏽‍♀️🦴&quot;, &quot;😀⭐️🧁&quot;, &quot;😀⭐️🦴&quot;, &quot;😀🧁🦴&quot;, &quot;🤷🏽‍♀️⭐️🧁&quot;, &quot;🤷🏽‍♀️⭐️🦴&quot;, &quot;🤷🏽‍♀️🧁🦴&quot;, &quot;⭐️🧁🦴&quot; ] Tuple When tuples are combined, the resulting list will also contain tuples. As part of the combination the original tuple is converted to a list, before the final values of the combination are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.combinations({:a, :b, :c, :d, :e}, 3) [ {:a, :b, :c}, {:a, :b, :d}, {:a, :b, :e}, {:a, :c, :d}, {:a, :c, :e}, {:a, :d, :e}, {:b, :c, :d}, {:b, :c, :e}, {:b, :d, :e}, {:c, :d, :e} ] iex&gt; Chunky.combinations({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}, [1, 2, 3]}, 3) [ {:task, ~D[2019-12-09], %{value: &quot;timer&quot;}}, {:task, ~D[2019-12-09], [1, 2, 3]}, {:task, %{value: &quot;timer&quot;}, [1, 2, 3]}, {~D[2019-12-09], %{value: &quot;timer&quot;}, [1, 2, 3]} ] Ranges Ranges can be used to create combinations over ordered lists of numbers. Before combination the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.combinations(3..6, 2) [ [3, 4], [3, 5], [3, 6], [4, 5], [4, 6], [5, 6] ] iex&gt; Chunky.combinations(-10..-13, 3) [ [-10, -11, -12], [-10, -11, -13], [-10, -12, -13], [-11, -12, -13] ] Examples iex&gt; Chunky.combinations([4, 3, 4, 3], 3) [[4, 3, 4], [4, 3, 3], [4, 4, 3], [3, 4, 3]] iex&gt; Chunky.combinations(&quot;abcd&quot;, 2) [&quot;ab&quot;, &quot;ac&quot;, &quot;ad&quot;, &quot;bc&quot;, &quot;bd&quot;, &quot;cd&quot;] iex&gt; Chunky.combinations({:a, :b, :c}, 1) [ {:a}, {:b}, {:c}] iex&gt; Chunky.combinations(2..-2, 3) [ [2, 1, 0], [2, 1, -1], [2, 1, -2], [2, 0, -1], [2, 0, -2], [2, -1, -2], [1, 0, -1], [1, 0, -2], [1, -1, -2], [0, -1, -2]]"},{"ref":"Chunky.html#permutations/1","title":"Chunky.permutations/1","type":"function","doc":"Generate all of the permutations, without duplicates, from a set of values. The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 This is not lazy generated, so a permutation of a large set may take awhile. Keep in mind that the total number of permutations for a set of N values is N!. When a set is permuted, the resulting list will contain values in the shape of the original; a permuted list will contains lists, permuted tuples will contain tuples, permuted strings will contain strings. The only exception is ranges, which will result in lists. So, for instance, a permuted string will result in a list of strings. Chunky should handle Unicode just fine: iex&gt; Chunky.permutations(&quot;😀★⍵&quot;) [&quot;😀★⍵&quot;, &quot;😀⍵★&quot;, &quot;★😀⍵&quot;, &quot;★⍵😀&quot;, &quot;⍵😀★&quot;, &quot;⍵★😀&quot;] Supported Permutations The Chunky.permutations/1 function can work with sets of any size (memory and time permitting). Examples that follow usually use sets with a length of 3 for ease of documentation. The following types of sets are supported as permutations: List A list with just about any kind of value can be permuted, and the result will be a list of lists: iex&gt; Chunky.permutations([1, 2, 3]) [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]] iex&gt; Chunky.permutations([:a, &quot;b&quot;, 3]) [ [:a, &quot;b&quot;, 3], [:a, 3, &quot;b&quot;], [&quot;b&quot;, :a, 3], [&quot;b&quot;, 3, :a], [3, :a, &quot;b&quot;], [3, &quot;b&quot;, :a] ] Collections, types, and other values can be permuted as well: iex&gt; Chunky.permutations([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}]) [ [~D[2019-12-05], %{a: &quot;foo&quot;}, {:tup, :le}], [~D[2019-12-05], {:tup, :le}, %{a: &quot;foo&quot;}], [%{a: &quot;foo&quot;}, ~D[2019-12-05], {:tup, :le}], [%{a: &quot;foo&quot;}, {:tup, :le}, ~D[2019-12-05]], [{:tup, :le}, ~D[2019-12-05], %{a: &quot;foo&quot;}], [{:tup, :le}, %{a: &quot;foo&quot;}, ~D[2019-12-05]] ] String/Binary Permuted strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.permutations(&quot;abc&quot;) [&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] iex&gt; Chunky.permutations(&quot;😀🤷🏽‍♀️⭐️&quot;) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀⭐️🤷🏽‍♀️&quot;, &quot;🤷🏽‍♀️😀⭐️&quot;, &quot;🤷🏽‍♀️⭐️😀&quot;, &quot;⭐️😀🤷🏽‍♀️&quot;, &quot;⭐️🤷🏽‍♀️😀&quot; ] Tuple When tuples are permuted, the resulting list will also contain tuples. As part of the permutation the original tuple is converted to a list, before the final values of the permutation are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.permutations({:a, :b, :c}) [ {:a, :b, :c}, {:a, :c, :b}, {:b, :a, :c}, {:b, :c, :a}, {:c, :a, :b}, {:c, :b, :a} ] iex&gt; Chunky.permutations({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}}) [ {:task, ~D[2019-12-09], %{value: &quot;timer&quot;}}, {:task, %{value: &quot;timer&quot;}, ~D[2019-12-09]}, {~D[2019-12-09], :task, %{value: &quot;timer&quot;}}, {~D[2019-12-09], %{value: &quot;timer&quot;}, :task}, {%{value: &quot;timer&quot;}, :task, ~D[2019-12-09]}, {%{value: &quot;timer&quot;}, ~D[2019-12-09], :task} ] Ranges Ranges can be used to create permutations over ordered lists of numbers. Before permutation the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.permutations(3..5) [[3, 4, 5], [3, 5, 4], [4, 3, 5], [4, 5, 3], [5, 3, 4], [5, 4, 3]] iex&gt; Chunky.permutations(-10..-12) [ [-10, -11, -12], [-10, -12, -11], [-11, -10, -12], [-11, -12, -10], [-12, -10, -11], [-12, -11, -10] ] Examples iex&gt; Chunky.permutations([1, 2, 3]) [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]] iex&gt; Chunky.permutations(&quot;abc&quot;) [&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] iex&gt; Chunky.permutations({:a, :b, :c}) [ {:a, :b, :c}, {:a, :c, :b}, {:b, :a, :c}, {:b, :c, :a}, {:c, :a, :b}, {:c, :b, :a} ] iex&gt; Chunky.permutations(1..-1) [ [1, 0, -1], [1, -1, 0], [0, 1, -1], [0, -1, 1], [-1, 1, 0], [-1, 0, 1]]"},{"ref":"readme.html","title":"Chunky","type":"extras","doc":"Chunky Chunking and Enumeration manipulations in Elixir. iex&gt; Chunky.permutations(&quot;😀🤷🏽‍♀️⭐️&quot;) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀⭐️🤷🏽‍♀️&quot;, &quot;🤷🏽‍♀️😀⭐️&quot;, &quot;🤷🏽‍♀️⭐️😀&quot;, &quot;⭐️😀🤷🏽‍♀️&quot;, &quot;⭐️🤷🏽‍♀️😀&quot; ] iex&gt; Chunky.combinations(1..4, 3) [[1, 2, 3], [1, 2, 4], [1, 3, 4], [2, 3, 4]] iex&gt; Chunky.chunk_length(10_000..10_100, 7) [ [10000, 10001, 10002, 10003, 10004, 10005, 10006], [10007, 10008, 10009, 10010, 10011, 10012, 10013], [10014, 10015, 10016, 10017, 10018, 10019, 10020], [10021, 10022, 10023, 10024, 10025, 10026, 10027], [10028, 10029, 10030, 10031, 10032, 10033, 10034], [10035, 10036, 10037, 10038, 10039, 10040, 10041], [10042, 10043, 10044, 10045, 10046, 10047, 10048], [10049, 10050, 10051, 10052, 10053, 10054, 10055], [10056, 10057, 10058, 10059, 10060, 10061, 10062], [10063, 10064, 10065, 10066, 10067, 10068, 10069], [10070, 10071, 10072, 10073, 10074, 10075, 10076], [10077, 10078, 10079, 10080, 10081, 10082, 10083], [10084, 10085, 10086, 10087, 10088, 10089, 10090], [10091, 10092, 10093, 10094, 10095, 10096, 10097], [10098, 10099, 10100] ]"},{"ref":"readme.html#installation","title":"Chunky - Installation","type":"extras","doc":"Install by adding chunky to your list of dependencies in mix.exs: def deps do [ {:chunky, &quot;~&gt; 0.3.0&quot;} ] end Chunky documentation can be found on Hexdocs at https://hexdocs.pm/chunky."},{"ref":"readme.html#documentation","title":"Chunky - Documentation","type":"extras","doc":"See Chunky on Hexdocs."}]